#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "structdata.h"


void elastic_Force (double FX[],double FY[],double FZ[],double npx[],double npy[],double npz[],double t,struct geo_data geo)
{
	int i,k;

	int ti,tj,tk,tl;
	double nptemp[12] = {0.0};

	for(i=0;i<tri_Num;i++)
	{
		ti = geo.triangle[i].point_i;
		tj = geo.triangle[i].point_j;
		tk = geo.triangle[i].point_k;
		tl = geo.triangle[i].point_l;

		nptemp[ 0] = npx[ti];
		nptemp[ 1] = npy[ti];
		nptemp[ 2] = npz[ti];

		nptemp[ 3] = npx[tj];
		nptemp[ 4] = npy[tj];
		nptemp[ 5] = npz[tj];

		nptemp[ 6] = npx[tk];
		nptemp[ 7] = npy[tk];
		nptemp[ 8] = npz[tk];

		nptemp[ 9] = npx[tl];
		nptemp[10] = npy[tl];
		nptemp[11] = npz[tl];

		for(k=0;k<12;k++)
		{
			FX[ti] += (geo.triangle[i].mat_lambda[ 0][k] * Lela + geo.triangle[i].mat_mu[ 0][k] * Mela) * nptemp[k];
			FY[ti] += (geo.triangle[i].mat_lambda[ 1][k] * Lela + geo.triangle[i].mat_mu[ 1][k] * Mela) * nptemp[k];
			FZ[ti] += (geo.triangle[i].mat_lambda[ 2][k] * Lela + geo.triangle[i].mat_mu[ 2][k] * Mela) * nptemp[k];
			
			FX[tj] += (geo.triangle[i].mat_lambda[ 3][k] * Lela + geo.triangle[i].mat_mu[ 3][k] * Mela) * nptemp[k];
			FY[tj] += (geo.triangle[i].mat_lambda[ 4][k] * Lela + geo.triangle[i].mat_mu[ 4][k] * Mela) * nptemp[k];
			FZ[tj] += (geo.triangle[i].mat_lambda[ 5][k] * Lela + geo.triangle[i].mat_mu[ 5][k] * Mela) * nptemp[k];
			
			FX[tk] += (geo.triangle[i].mat_lambda[ 6][k] * Lela + geo.triangle[i].mat_mu[ 6][k] * Mela) * nptemp[k];
			FY[tk] += (geo.triangle[i].mat_lambda[ 7][k] * Lela + geo.triangle[i].mat_mu[ 7][k] * Mela) * nptemp[k];
			FZ[tk] += (geo.triangle[i].mat_lambda[ 8][k] * Lela + geo.triangle[i].mat_mu[ 8][k] * Mela) * nptemp[k];
			
			FX[tl] += (geo.triangle[i].mat_lambda[ 9][k] * Lela + geo.triangle[i].mat_mu[ 9][k] * Mela) * nptemp[k];
			FY[tl] += (geo.triangle[i].mat_lambda[10][k] * Lela + geo.triangle[i].mat_mu[10][k] * Mela) * nptemp[k];
			FZ[tl] += (geo.triangle[i].mat_lambda[11][k] * Lela + geo.triangle[i].mat_mu[11][k] * Mela) * nptemp[k];
		}
	}
}