/********************************************************/
/*	3D	soft object deformation simurator				*/
/*										FEM model		*/
/*										ver.18.3		*/
/*			Last updata:2006/8/4	Junji Muramatsu		*/
/*          Op@Tvf̃f@@@@@@@@@*/
/********************************************************/
/*	<<Updata Information>>							*/
/*	2̓mFς							*/
/*	΂߃GbWׂ͂̕čォE		*/
/*	Lumped Inertia Matrix Model						*/
/*	wide=1,height=1̏ꍇmFς			*/
/*	elastic,voigt,maxwell,and three-element model	*/
/*	V~[V̌oߎԕ\ǉ				*/
/*	V~[VvZʂ̍팸					*/
/*	compValueύX(vOC)(05/10/12)			*/
/*	ψʃvOǉ(05/10/12)				*/
/*	ψʁCO͈֐(05/10/13)			*/
/*	f[^擾Ԋuݒł悤ɂ(05/10/13)	*/
/*	ψʕێvOǉ(05/10/16)			*/
/*	2݂̂̌ύX\ɂ(05/10/20)		*/
/*	ڑs񐶐vOǉ(05/10/26)		*/
/*	iq_WCԍCOp`vf_ԍ		*/

/*	3mF	i06/08/04j					*/
/*	eOp`̊sMp̌vZ̕ύX	(06/08/08)	*/
/*	QNb^tFo[O@ǉ		(06/08/15)	*/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <conio.h>
#include <windows.h>
#include <time.h>
#include "RK.H"
#include "data.h"
#include "func.h"
#include "geodata.h"
#include "structdata.h"

static void differential(int n, double x[], double t, double value[], struct geo_data geo)
{
	int q = 0;
	int r = 0;

	static double	FexX[node_Num]	={0.0};		//Ox
	static double	FexY[node_Num]	={0.0};		//Oy
	static double	FexZ[node_Num]	={0.0};		//Oz

	double	FX[node_Num] = {0.0};		//lʑ̗vfό`ɂ锭
	double	FY[node_Num] = {0.0};
	double	FZ[node_Num] = {0.0};

	double	npx[node_Num] = {0.0};				//_W
	double	npy[node_Num] = {0.0};
	double	npz[node_Num] = {0.0};

	double	nsx[node_Num] = {0.0};				//_ψʑx
	double	nsy[node_Num] = {0.0};
	double	nsz[node_Num] = {0.0};

	double	wlax[node_Num] = {0.0};				//for maxwell and three-element model
	double	wlay[node_Num] = {0.0};
	double	wlaz[node_Num] = {0.0};
	double	wmux[node_Num] = {0.0};
	double	wmuy[node_Num] = {0.0};
	double	wmuz[node_Num] = {0.0};

	double	LMX[node_Num] = {0.0};				//ʍSCSMɂS
	double	LMY[node_Num] = {0.0};
	double	LMZ[node_Num] = {0.0};

	for(q=0;q<node_Num;q++)
	{
		npx[q]	= x[3*q+0+(0*node_Num)];		//_W
		npy[q]	= x[3*q+1+(0*node_Num)];
		npz[q]	= x[3*q+2+(0*node_Num)];

		nsx[q]	= x[3*q+0+(3*node_Num)];		//_ψʑx
		nsy[q]	= x[3*q+1+(3*node_Num)];
		nsz[q]	= x[3*q+2+(3*node_Num)];

		wlax[q]	= x[3*q+0+(6*node_Num)];		//for maxwell and three-element model
		wlay[q]	= x[3*q+1+(6*node_Num)];
		wlaz[q]	= x[3*q+2+(6*node_Num)];

		wmux[q]	= x[3*q+0+(9*node_Num)];
		wmuy[q]	= x[3*q+1+(9*node_Num)];
		wmuz[q]	= x[3*q+2+(9*node_Num)];

		LMX[q] = x[3*q+0+(12*node_Num)];		//ʍSCSMɂS
		LMY[q] = x[3*q+1+(12*node_Num)];
		LMZ[q] = x[3*q+2+(12*node_Num)];

	}

/*------3D<<select>>computing of model force (e_ɂ郂f͂̌vZCf̑I)---------*/
	if(VISELA)		/*--VISELA--*/
		viscoelastic_Force(FX,FY,FZ,nsx,nsy,nsz,npx,npy,npz,value,t,geo);									//voigt model

	else if(VISPLA)		/*--VISPLA--*/
		viscoplastic_Force(FX,FY,FZ,wlax,wlay,wlaz,wmux,wmuy,wmuz,value,nsx,nsy,nsz,t,geo);			//maxwell model

	else if(THREEELE)	/*--THREEELE--*/
		threeElement_Force(FX,FY,FZ,wlax,wlay,wlaz,wmux,wmuy,wmuz,value,nsx,nsy,nsz,t,geo);			//three-element model

	else if(ELA)			/*--ELA--*/
		elastic_Force(FX,FY,FZ,npx,npy,npz,t,geo);													//elastic model

//---------------------------------------------//

	if(EX)				//--O͈֐--//
		add_exforce(FX,FY,FZ,FexX,FexY,FexZ,t);

	if(GRAVI)
		add_gravitation(FX,FY,FZ,FexX,FexY,FexZ,t);

/*----------------------computing of analysis value-------------------------*/

	compValue(FX,FY,FZ,nsx,nsy,nsz,npx,npy,npz,x,value,LMX,LMY,LMZ,t,geo);	


	if(CSM)		//--ψʗp֐CSM--//
		add_csmmove(npx,npy,npz,nsx,nsy,nsz,value,t);

/*------------------------̓f[^̕ۑ--------------------------*/
	if(FORCE_DATA)
	{
		for(q=0;q<node_Num;q++)
		{
			value[3*q+0+(15*node_Num)] = FX[q];
			value[3*q+1+(15*node_Num)] = FY[q];
			value[3*q+2+(15*node_Num)] = FZ[q];
		}
	}


//-----------for debug----------------//

//if(x[node_Num*2-2]>=1000 || x[node_Num*2-2]<=-1000)
	if(npy[node_Num] < -1000.0)
	{
		printf("ERROR\r");
	}

//-------------------------------------//

}

void main()
{
	double startTime = timeGetTime();
	int		kcnt;
	double	t, dt, tend;
	int		cnt			= 0;
	double	x[NumVars] = {0.0};
	char	*filename	= "result.dat";
	char	*filename2	= "geodata.dat";
	char	*filename3	= "tridata.dat";

	FILE	*fd,*fg,*ft;
	
	if ((fd = fopen(filename,"w")) == NULL) {
		fprintf(stderr, "cannot open %s\n", filename);
		exit(1);
	}

	if ((fg = fopen(filename2,"w")) == NULL) {
		fprintf(stderr, "cannot open %s\n", filename2);
		exit(1);
	}

	if ((ft = fopen(filename3,"w")) == NULL) {
		fprintf(stderr, "cannot open %s\n", filename3);
		exit(1);
	}

	dt = s_time;							//sampling time
	tend = sim_time;
	kcnt = (int)(sim_time/dt);//1000;		//loop count

	/* kcnt * dt = 10 [sec] */

	/*	sʕ\p(p[^o)	*/
	printf("Simulation of 3D soft object deformation of a rectangular object(FEM MODEL)\n");
	printf("Ver.%2.1lf\n\n",version);
	printf("\tsimulation time\t\t: %d[s]\n",sim_time);
	printf("\tsampling time\t\t: %lf[s]\n",s_time);
	if(RUNGE_F)
	{
		printf("\tSafetyRatio\t\t: %lf\n",SafetyRatio);
		printf("\tAllowance\t\t: %lf\n",Allowance);
	}
	printf("\tloop count\t\t: %d\n",kcnt);
	printf("\tobject\t\t\t: %d~%d~%d\n\tnodes\t\t\t: %d\n",wide,height,depth,node_Num);
	printf("\telement\t\t\t: %d\n", elem_num);
	printf("\tobject size\t\t: %.0lf[mm]~%.0lf[mm]~%.0lf[mm]\n",wide*tri_wide*1000,height*tri_height*1000,depth*tri_depth*1000);
	if(CSM)
	{
		if(move_x)
			printf("\tConstraintMove x\t: %.1lf[mm]\n",move_x*1000);
		if(move_y)
			printf("\tConstraintMove y\t: %.1lf[mm]\n",move_y*1000);
		if(move_z)
			printf("\tConstraintMove z\t: %.1lf[mm]\n",move_z*1000);
	}
	if(EX)
	{
		if(exforce_x)
			printf("\tExforce x\t\t: %lf[N]\n",exforce_x);
		if(exforce_y)
			printf("\tExforce y\t\t: %lf[N]\n",exforce_y);
		if(exforce_z)
			printf("\tExforce z\t\t: %lf[N]\n",exforce_z);
	}
	printf("\tPoisson's ratio Nela\t: %lf\n",Nela);
	printf("\tPoisson's ratio Nvis\t: %lf\n",Nvis);
	printf("\tPoisson's ratio Ntvis\t: %lf\n",Ntvis);


	printf("\tYoung's modulous\t: %lf\n",E);
	printf("\tViscous modulous\t: %lf\n\n",C);
	
	printf("\tmass\t\t: %.0lf[g](nodal mass\t: %lf[g])\n\tdensity\t\t: %lf\n",MASS*1000,MASS/(node_Num)*1000,D);
	if(push_case==3)
		printf("\tex_wide\t\t: %d[mesh]\n\tex_depth\t: %d[mesh]\n\n",ex_wide,ex_depth);
	printf("Start simulation\n");

	/* initial value */
	t = 0.0;

	static struct geo_data geo;		//􉽏p\̐錾


	//̂̊̕iq_WCOp`vf̒_ԍW[-----
	make_GeoData(fg,ft,&geo);
	//---------------------------------------------------------------

	//lʑ̗vf̕ڑsC̐ρC[̒萔W[-----
	make_MatandArea(fg,&geo);
	//---------------------------------------------------------------

	//eOp`̊sMp̌vZ(lumped inertia matrix)-------------------
	lumped_inertia_mat(&geo);

	fclose(fg);
	fclose(ft);

#if	RUNGE
	RungeKuttafprint(fd, NumVars, x, t);	// print initial values
	RungeKutta(fd, NumVars, x, differential, &t, dt, kcnt, geo);
#endif//runge

#if	RUNGE_F
	RungeKuttaFehlbergAdaptivefprint(fd, NumVars, x, t, dt, &cnt);	// print initial values
	RungeKuttaFehlbergAdaptive(fd, NumVars, x, differential, &t, &dt, tend, kcnt, geo, &cnt);
#endif//rungefehl

	double Time = timeGetTime();
	
	printf("\n\n");
	printf("End of simulation\treal time:%lf[s]\n",(Time-startTime)/CLOCKS_PER_SEC);
	printf("time per 1 loop(ave.) = %lf[ms]\n",(Time-startTime)/(kcnt));		//Runge-Kutta 1[v̕ώԕ\[ms]
	//Release:	about 0.138[ms] 
	//Debug:	about 0.48[ms]

	
	fclose(fd);

}

