#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "structdata.h"

void threeElement_Force (double FX[],double FY[],double FZ[],double wlax[],double wlay[],double wlaz[],
						 double wmux[],double wmuy[],double wmuz[],double value[],double nsx[],double nsy[],double nsz[],
						 double t,struct geo_data geo)
{
	int i,q;

	int ti,tj,tk,tl;
	
	double wlatemp[12] = {0.0};
	double wmutemp[12] = {0.0};
	double nstemp[12] = {0.0};
	
	for(i=0,q=0;i<tri_Num;i++)
	{
		ti = geo.triangle[i].point_i;
		tj = geo.triangle[i].point_j;
		tk = geo.triangle[i].point_k;
		tl = geo.triangle[i].point_l;

		wlatemp[ 0] = wlax[ti];	wlatemp[ 1] = wlay[ti];	wlatemp[ 2] = wlaz[ti];
		wlatemp[ 3] = wlax[tj];	wlatemp[ 4] = wlay[tj];	wlatemp[ 5] = wlaz[tj];
		wlatemp[ 6] = wlax[tk];	wlatemp[ 7] = wlay[tk];	wlatemp[ 8] = wlaz[tk];
		wlatemp[ 9] = wlax[tl];	wlatemp[10] = wlay[tl];	wlatemp[11] = wlaz[tl];

		wmutemp[ 0] = wmux[ti];	wmutemp[ 1] = wmuy[ti];	wmutemp[ 2] = wmuz[ti];
		wmutemp[ 3] = wmux[tj];	wmutemp[ 4] = wmuy[tj];	wmutemp[ 5] = wmuz[tj];
		wmutemp[ 6] = wmux[tk];	wmutemp[ 7] = wmuy[tk];	wmutemp[ 8] = wmuz[tk];
		wmutemp[ 9] = wmux[tl];	wmutemp[10] = wmuy[tl];	wmutemp[11] = wmuz[tl];

		nstemp[ 0] = nsx[ti];	nstemp[ 1] = nsy[ti];	nstemp[ 2] = nsz[ti];
		nstemp[ 3] = nsx[tj];	nstemp[ 4] = nsy[tj];	nstemp[ 5] = nsz[tj];
		nstemp[ 6] = nsx[tk];	nstemp[ 7] = nsy[tk];	nstemp[ 8] = nsz[tk];
		nstemp[ 9] = nsx[tl];	nstemp[10] = nsy[tl];	nstemp[11] = nsz[tl];


		for(q=0;q<12;q++)
		{
			FX[ti] +=	geo.triangle[i].mat_lambda[0][q] * (wlatemp[q] + Lvis * nstemp[q]) +
						geo.triangle[i].mat_mu[0][q] * (wmutemp[q] + Mvis*nstemp[q]);

			FY[ti] +=	geo.triangle[i].mat_lambda[1][q] * (wlatemp[q] + Lvis * nstemp[q]) +
						geo.triangle[i].mat_mu[1][q] * (wmutemp[q] + Mvis * nstemp[q]);

			FZ[ti] +=	geo.triangle[i].mat_lambda[2][q] * (wlatemp[q] + Lvis * nstemp[q]) +
						geo.triangle[i].mat_mu[2][q] * (wmutemp[q] + Mvis * nstemp[q]);


			FX[tj] +=	geo.triangle[i].mat_lambda[3][q] * (wlatemp[q] + Lvis * nstemp[q]) +
						geo.triangle[i].mat_mu[3][q] * (wmutemp[q] + Mvis * nstemp[q]);

			FY[tj] +=	geo.triangle[i].mat_lambda[4][q] * (wlatemp[q] + Lvis * nstemp[q]) +
						geo.triangle[i].mat_mu[4][q] * (wmutemp[q] + Mvis * nstemp[q]);

			FY[tj] +=	geo.triangle[i].mat_lambda[5][q] * (wlatemp[q] + Lvis * nstemp[q]) +
						geo.triangle[i].mat_mu[5][q] * (wmutemp[q] + Mvis * nstemp[q]);


			FX[tk] +=	geo.triangle[i].mat_lambda[6][q] * (wlatemp[q] + Lvis * nstemp[q]) +
						geo.triangle[i].mat_mu[6][q] * (wmutemp[q] + Mvis * nstemp[q]);

			FY[tk] +=	geo.triangle[i].mat_lambda[7][q] * (wlatemp[q] + Lvis * nstemp[q]) +
						geo.triangle[i].mat_mu[7][q] * (wmutemp[q] + Mvis * nstemp[q]);

			FY[tk] +=	geo.triangle[i].mat_lambda[8][q] * (wlatemp[q] + Lvis * nstemp[q]) +
						geo.triangle[i].mat_mu[8][q] * (wmutemp[q] + Mvis * nstemp[q]);

			
			FX[tl] +=	geo.triangle[i].mat_lambda[9][q] * (wlatemp[q] + Lvis * nstemp[q]) +
						geo.triangle[i].mat_mu[9][q] * (wmutemp[q] + Mvis * nstemp[q]);

			FY[tl] +=	geo.triangle[i].mat_lambda[10][q] * (wlatemp[q] + Lvis * nstemp[q]) +
						geo.triangle[i].mat_mu[10][q] * (wmutemp[q] + Mvis * nstemp[q]);

			FY[tl] +=	geo.triangle[i].mat_lambda[11][q] * (wlatemp[q] + Lvis * nstemp[q]) +
						geo.triangle[i].mat_mu[11][q] * (wmutemp[q] + Mvis * nstemp[q]);
						
		}
	}

	//ύXKv
	for(i=0;i<node_Num;i++)
	{
		value[3*i+(6*node_Num)]		= -(Lela/(Lvis+Ltvis))*(wlax[i]-Ltvis*nsx[i]);
		value[3*i+(6*node_Num+1)]	= -(Lela/(Lvis+Ltvis))*(wlay[i]-Ltvis*nsy[i]);
		value[3*i+(6*node_Num+2)]	= -(Lela/(Lvis+Ltvis))*(wlaz[i]-Ltvis*nsz[i]);

		value[3*i+(9*node_Num)]		= -(Mela/(Mvis+Mtvis))*(wmux[i]-Mtvis*nsx[i]);
		value[3*i+(9*node_Num+1)]	= -(Mela/(Mvis+Mtvis))*(wmuy[i]-Mtvis*nsy[i]);
		value[3*i+(9*node_Num+2)]	= -(Mela/(Mvis+Mtvis))*(wmuz[i]-Mtvis*nsz[i]);
	}
}