#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "structdata.h"

void viscoelastic_Force (double FX[],double FY[],double FZ[],double nsx[],double nsy[],double nsz[],
						 double npx[],double npy[],double npz[],double value[],double t,struct geo_data geo){
	int i,q;

	int ti,tj,tk,tl;
	double nptemp[12] = {0.0};
	double nstemp[12] = {0.0};
	
	for(i=0,q=0;i<tri_Num;i++)
	{
		ti = geo.triangle[i].point_i;
		tj = geo.triangle[i].point_j;
		tk = geo.triangle[i].point_k;
		tl = geo.triangle[i].point_l;

		nptemp[ 0] = npx[ti];	nptemp[ 1] = npy[ti];	nptemp[ 2] = npz[ti];
		nptemp[ 3] = npx[tj];	nptemp[ 4] = npy[tj];	nptemp[ 5] = npz[tj];
		nptemp[ 6] = npx[tk];	nptemp[ 7] = npy[tk];	nptemp[ 8] = npz[tk];
		nptemp[ 9] = npx[tl];	nptemp[10] = npy[tl];	nptemp[11] = npz[tl];

		nstemp[ 0] = nsx[ti];	nstemp[ 1] = nsy[ti];	nstemp[ 2] = nsz[ti];
		nstemp[ 3] = nsx[tj];	nstemp[ 4] = nsy[tj];	nstemp[ 5] = nsz[tj];
		nstemp[ 6] = nsx[tk];	nstemp[ 7] = nsy[tk];	nstemp[ 8] = nsz[tk];
		nstemp[ 9] = nsx[tl];	nstemp[10] = nsy[tl];	nstemp[11] = nsz[tl];

		for(q=0;q<12;q++)
		{

			FX[ti] +=	geo.triangle[i].mat_lambda[0][q] * (Lela * nptemp[q] + Lvis * nstemp[q])+
							geo.triangle[i].mat_mu[0][q] * (Mela * nptemp[q] + Mvis * nstemp[q]);

			FY[ti] +=	geo.triangle[i].mat_lambda[1][q] * (Lela * nptemp[q] + Lvis * nstemp[q])+
							geo.triangle[i].mat_mu[1][q] * (Mela * nptemp[q] + Mvis * nstemp[q]);

			FZ[ti] +=	geo.triangle[i].mat_lambda[2][q] * (Lela * nptemp[q] + Lvis * nstemp[q])+
							geo.triangle[i].mat_mu[2][q] * (Mela * nptemp[q] + Mvis * nstemp[q]);


			FX[tj] +=	geo.triangle[i].mat_lambda[3][q] * (Lela * nptemp[q] + Lvis * nstemp[q])+
							geo.triangle[i].mat_mu[3][q] * (Mela * nptemp[q] + Mvis * nstemp[q]);

			FY[tj] +=	geo.triangle[i].mat_lambda[4][q] * (Lela * nptemp[q] + Lvis * nstemp[q])+
							geo.triangle[i].mat_mu[4][q] * (Mela * nptemp[q] + Mvis * nstemp[q]);

			FZ[tj] +=	geo.triangle[i].mat_lambda[5][q] * (Lela * nptemp[q] + Lvis * nstemp[q])+
							geo.triangle[i].mat_mu[5][q] * (Mela * nptemp[q] + Mvis * nstemp[q]);


			FX[tk] +=	geo.triangle[i].mat_lambda[6][q] * (Lela * nptemp[q] + Lvis * nstemp[q])+
							geo.triangle[i].mat_mu[6][q] * (Mela * nptemp[q] + Mvis * nstemp[q]);

			FY[tk] +=	geo.triangle[i].mat_lambda[7][q] * (Lela * nptemp[q] + Lvis * nstemp[q])+
							geo.triangle[i].mat_mu[7][q] * (Mela * nptemp[q] + Mvis * nstemp[q]);

			FZ[tk] +=	geo.triangle[i].mat_lambda[8][q] * (Lela * nptemp[q] + Lvis * nstemp[q])+
							geo.triangle[i].mat_mu[8][q] * (Mela * nptemp[q] + Mvis * nstemp[q]);


			FX[tl] +=	geo.triangle[i].mat_lambda[9][q] * (Lela * nptemp[q] + Lvis * nstemp[q])+
							geo.triangle[i].mat_mu[9][q] * (Mela * nptemp[q] + Mvis * nstemp[q]);

			FY[tl] +=	geo.triangle[i].mat_lambda[10][q] * (Lela * nptemp[q] + Lvis * nstemp[q])+
							geo.triangle[i].mat_mu[10][q] * (Mela * nptemp[q] + Mvis * nstemp[q]);

			FZ[tl] +=	geo.triangle[i].mat_lambda[11][q] * (Lela * nptemp[q] + Lvis * nstemp[q])+
							geo.triangle[i].mat_mu[11][q] * (Mela * nptemp[q] + Mvis * nstemp[q]);
		}
	}
}
