#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "structdata.h"

void viscoplastic_Force (double FX[],double FY[],double FZ[],double wlax[],double wlay[],double wlaz[],
						 double wmux[],double wmuy[],double wmuz[],double value[],
						 double nsx[],double nsy[],double nsz[],double t,struct geo_data geo)
{
	int i,k,q;

	int ti,tj,tk,tl;
	double wlatemp[12] = {0.0};
	double wmutemp[12] = {0.0};
	
	for(i=0;i<tri_Num;i++)
	{
		ti = geo.triangle[i].point_i;
		tj = geo.triangle[i].point_j;
		tk = geo.triangle[i].point_k;
		tl = geo.triangle[i].point_l;

		wlatemp[ 0] = wlax[ti];	wlatemp[ 1] = wlay[ti];	wlatemp[ 2] = wlaz[ti];
		wlatemp[ 3] = wlax[tj];	wlatemp[ 4] = wlay[tj];	wlatemp[ 5] = wlaz[tj];
		wlatemp[ 6] = wlax[tk];	wlatemp[ 7] = wlay[tk];	wlatemp[ 8] = wlaz[tk];
		wlatemp[ 9] = wlax[tl];	wlatemp[10] = wlay[tl];	wlatemp[11] = wlaz[tl];

		wmutemp[ 0] = wmux[ti];	wmutemp[ 1] = wmuy[ti];	wmutemp[ 2] = wmuz[ti];
		wmutemp[ 3] = wmux[tj];	wmutemp[ 4] = wmuy[tj];	wmutemp[ 5] = wmuz[tj];
		wmutemp[ 6] = wmux[tk];	wmutemp[ 7] = wmuy[tk];	wmutemp[ 8] = wmuz[tk];
		wmutemp[ 9] = wmux[tl];	wmutemp[10] = wmuy[tl];	wmutemp[11] = wmuz[tl];

		for(k=0;k<12;k++)
		{
			FX[ti] +=	geo.triangle[i].mat_lambda[ 0][k] * wlatemp[k] + geo.triangle[i].mat_mu[ 0][k] * wmutemp[k];
			FY[ti] +=	geo.triangle[i].mat_lambda[ 1][k] * wlatemp[k] + geo.triangle[i].mat_mu[ 1][k] * wmutemp[k];
			FZ[ti] +=	geo.triangle[i].mat_lambda[ 2][k] * wlatemp[k] + geo.triangle[i].mat_mu[ 2][k] * wmutemp[k];

			FX[tj] +=	geo.triangle[i].mat_lambda[ 3][k] * wlatemp[k] + geo.triangle[i].mat_mu[ 3][k] * wmutemp[k];
			FY[tj] +=	geo.triangle[i].mat_lambda[ 4][k] * wlatemp[k] + geo.triangle[i].mat_mu[ 4][k] * wmutemp[k];
			FZ[tj] +=	geo.triangle[i].mat_lambda[ 5][k] * wlatemp[k] + geo.triangle[i].mat_mu[ 5][k] * wmutemp[k];

			FX[tk] +=	geo.triangle[i].mat_lambda[ 6][k] * wlatemp[k] + geo.triangle[i].mat_mu[ 6][k] * wmutemp[k];
			FY[tk] +=	geo.triangle[i].mat_lambda[ 7][k] * wlatemp[k] + geo.triangle[i].mat_mu[ 7][k] * wmutemp[k];
			FZ[tk] +=	geo.triangle[i].mat_lambda[ 8][k] * wlatemp[k] + geo.triangle[i].mat_mu[ 8][k] * wmutemp[k];

			FX[tl] +=	geo.triangle[i].mat_lambda[ 9][k] * wlatemp[k] + geo.triangle[i].mat_mu[ 9][k] * wmutemp[k];
			FY[tl] +=	geo.triangle[i].mat_lambda[10][k] * wlatemp[k] + geo.triangle[i].mat_mu[10][k] * wmutemp[k];
			FZ[tl] +=	geo.triangle[i].mat_lambda[11][k] * wlatemp[k] + geo.triangle[i].mat_mu[11][k] * wmutemp[k];

		}
	}

	for(q=0;q<node_Num;q++)
	{
		value[3*q  +(6*node_Num)]	= -(Lela/Lvis)*wlax[q]+Lela*nsx[q];
		value[3*q+1+(6*node_Num)]	= -(Lela/Lvis)*wlay[q]+Lela*nsy[q];
		value[3*q+2+(6*node_Num)]	= -(Lela/Lvis)*wlaz[q]+Lela*nsz[q];

		value[3*q  +(9*node_Num)]	= -(Mela/Mvis)*wmux[q]+Mela*nsx[q];
		value[3*q+1+(9*node_Num)]	= -(Mela/Mvis)*wmuy[q]+Mela*nsy[q];
		value[3*q+2+(9*node_Num)]	= -(Mela/Mvis)*wmuz[q]+Mela*nsz[q];
	}
}